﻿Imports System.Runtime.InteropServices

Public Class Form1

    Private Const SETPOWERMANAGEMENT As Int32 = 6147

    <DllImport("CoreDll")> _
    Private Shared Function ExtEscape( _
    ByVal hdc As IntPtr, _
    ByVal nEscape As Integer, _
    ByVal cbInput As Integer, _
    ByVal plszInData As Byte(), _
    ByVal cbOutput As Integer, _
    ByVal lpszOutData As IntPtr) As Integer
    End Function

    <DllImport("CoreDll")> _
    Private Shared Function GetDC( _
    ByVal hwnd As IntPtr) As IntPtr
    End Function

    Public Enum VideoPowerState As Integer
        VideoPowerOn = 1
        VideoPowerStandBy
        VideoPowerSuspend
        VideoPowerOff
    End Enum

    Public Shared Sub VideoPowerOff()
        Dim hdc As IntPtr = GetDC(IntPtr.Zero)
        Dim vpm() As Byte = { _
        12, 0, 0, 0, 1, 0, 0, 0, _
        VideoPowerState.VideoPowerOff, _
        0, 0, 0, 0}
        ExtEscape( _
        hdc, SETPOWERMANAGEMENT, 12, vpm, 0, IntPtr.Zero)
    End Sub

    Public Shared Sub VideoPowerOn()
        Dim hdc As IntPtr = GetDC(IntPtr.Zero)
        Dim vpm() As Byte = { _
        12, 0, 0, 0, 1, 0, 0, 0, _
        VideoPowerState.VideoPowerOn, _
        0, 0, 0, 0}
        ExtEscape( _
        hdc, SETPOWERMANAGEMENT, 12, vpm, 0, IntPtr.Zero)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Timer1.Interval = 5000
        Timer1.Enabled = True
        VideoPowerOff()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Timer1.Enabled = False
        VideoPowerOn()
    End Sub
End Class
