﻿Public Class Form1

    Private Sub Form1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint

        'ペンの定義
        Dim redpen As New Pen(Color.Red, 12)
        Dim bluepen As New Pen(Color.Blue, 8)

        'ブラシの定義
        Dim yellowbrush As New SolidBrush(Color.Yellow)
        Dim greenbrush As New SolidBrush(Color.Green)
        Dim graybrush As New SolidBrush(Color.LightGray)

        'フォントの定義
        Dim mytahoma As New Font("Tahoma", 24, FontStyle.Bold Or FontStyle.Italic)

        'グラフィックオブジェクトの作成
        Dim g As Graphics = e.Graphics

        '描画処理
        g.DrawString("Windows" + vbCrLf + "Phone", mytahoma, greenbrush, 70, 110)
        g.DrawEllipse(redpen, 240, 20, 200, 200)
        g.DrawLine(bluepen, 20, 20, 20, 560)
        g.DrawRectangle(bluepen, 60, 100, 300, 200)
        g.FillEllipse(graybrush, 65, 345, 100, 160)
        g.FillEllipse(yellowbrush, 60, 340, 100, 160)
        g.FillRectangle(graybrush, 210, 350, 200, 160)
        g.FillRectangle(greenbrush, 200, 340, 200, 160)

        ' オブジェクトの解放
        redpen.Dispose()
        bluepen.Dispose()
        yellowbrush.Dispose()
        greenbrush.Dispose()
        mytahoma.Dispose()
        g.Dispose()

    End Sub

    Private Sub Form1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown

        'ブラシの定義
        Dim magentabrush As New SolidBrush(Color.Magenta)

        'グラフィックオブジェクトの作成
        Dim g As Graphics = CreateGraphics()

        ' ハートを描く
        Dim r As Integer = New Random().Next(20, 40)
        g.FillRectangle(magentabrush, e.X, e.Y, r, r)
        g.FillEllipse(magentabrush, e.X, e.Y - r / 2, r, r)
        g.FillEllipse(magentabrush, e.X + r / 2, e.Y - 1, r, r)

        ' オブジェクトの解放
        g.Dispose()
        magentabrush.Dispose()

    End Sub
End Class
