﻿Imports System.Net
Imports System.IO

Public Class utility

    Public Const key As String = "EdtterPasskey"

    Public Shared Function ReadData(ByVal url As String, ByVal user As String, ByVal pass As String) As String
        Dim nc As System.Net.NetworkCredential = New System.Net.NetworkCredential(user, pass)
        Dim request As HttpWebRequest = CType(HttpWebRequest.Create(url), HttpWebRequest)
        request.Credentials = nc
        Dim response As WebResponse
        Try
            response = request.GetResponse()
        Catch ex As Exception
            Return ""
        End Try
        Dim reader As StreamReader = New StreamReader(response.GetResponseStream())
        Dim result As String = reader.ReadToEnd()
        reader.Close()
        response.Close()
        Return result
    End Function

    Public Shared Function EncryptString(ByVal str As String, ByVal key As String) As String

        Dim bytesIn As Byte() = System.Text.Encoding.UTF8.GetBytes(str)
        Dim des As New System.Security.Cryptography.DESCryptoServiceProvider
        Dim bytesKey As Byte() = System.Text.Encoding.UTF8.GetBytes(key)
        des.Key = ResizeBytesArray(bytesKey, des.Key.Length)
        des.IV = ResizeBytesArray(bytesKey, des.IV.Length)

        Dim msOut As New System.IO.MemoryStream
        Dim desdecrypt As System.Security.Cryptography.ICryptoTransform = des.CreateEncryptor()
        Dim cryptStreem As New System.Security.Cryptography.CryptoStream( _
            msOut, desdecrypt, _
            System.Security.Cryptography.CryptoStreamMode.Write)

        cryptStreem.Write(bytesIn, 0, bytesIn.Length)
        cryptStreem.FlushFinalBlock()
        Dim bytesOut As Byte() = msOut.ToArray()

        cryptStreem.Close()
        msOut.Close()

        Return System.Convert.ToBase64String(bytesOut)
    End Function

    Public Shared Function DecryptString(ByVal str As String, ByVal key As String) As String

        Dim des As New System.Security.Cryptography.DESCryptoServiceProvider
        Dim bytesKey As Byte() = System.Text.Encoding.UTF8.GetBytes(key)
        des.Key = ResizeBytesArray(bytesKey, des.Key.Length)
        des.IV = ResizeBytesArray(bytesKey, des.IV.Length)

        Dim bytesIn As Byte() = System.Convert.FromBase64String(str)
        Dim msIn As New System.IO.MemoryStream(bytesIn)
        Dim desdecrypt As System.Security.Cryptography.ICryptoTransform = _
            des.CreateDecryptor()

        Dim cryptStreem As New System.Security.Cryptography.CryptoStream( _
            msIn, desdecrypt, _
            System.Security.Cryptography.CryptoStreamMode.Read)

        Dim srOut As New System.IO.StreamReader( _
            cryptStreem, System.Text.Encoding.UTF8)
        Dim result As String = srOut.ReadToEnd()

        srOut.Close()
        cryptStreem.Close()
        msIn.Close()


        Return result

    End Function

    Private Shared Function ResizeBytesArray(ByVal bytes() As Byte, ByVal newSize As Integer) As Byte()
        Dim newBytes(newSize - 1) As Byte
        If bytes.Length < newSize Then
            Dim i As Integer
            For i = 0 To bytes.Length - 1
                newBytes(i) = bytes(i)
            Next i
        Else
            Dim pos As Integer = 0
            Dim i As Integer
            For i = newSize To bytes.Length - 1
                newBytes(pos) = newBytes(pos) Xor bytes(i)
                pos += 1
                If pos >= newBytes.Length Then
                    pos = 0
                End If
            Next i
        End If
        Return newBytes
    End Function

End Class
