﻿Imports Microsoft.Win32

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        ' HKEY_CURRENT_USER¥Software¥test¥subkey に書き込む
        Dim rkey As RegistryKey = _
        Registry.CurrentUser.CreateSubKey("Software¥test¥subkey")
        '文字列(REG_SZ)書き込み
        rkey.SetValue("strdata", Me.TextBox1.Text)
        '整数(REG_DWORD)書き込み
        rkey.SetValue("int", 100)
        '文字列配列(REG_MULTI_SZ)書き込み
        Dim s As String() = {"data1", "data2", "data3"}
        rkey.SetValue("stringarray", s)
        'バイト配列(REG_BINARY)書き込み
        Dim bs As Byte() = {0, 1, 2}
        rkey.SetValue("Byte", bs)
        'レジストリキーを閉じる
        rkey.Close()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        ' HKEY_CURRENT_USER¥Software¥test¥subkey を読み込み専用(False) で開く
        Dim rkey As RegistryKey = _
        Registry.CurrentUser.OpenSubKey("Software¥test¥subkey", False)
        'キーがない場合は終了
        If rkey Is Nothing Then Return
        '文字列データを取得
        Me.Label3.Text = CType(rkey.GetValue("strdata"), String)
        'サブキーの数を取得
        Me.TextBox2.Text = _
        "サブキー数：" + rkey.SubKeyCount.ToString() + vbCrLf
        'キー一覧を取得
        Dim keys() As String = rkey.GetValueNames()
        For Each key As String In keys
            Me.TextBox2.Text += key.ToString + vbCrLf
        Next
        'レジストリキーを閉じる
        rkey.Close()
    End Sub
End Class
