﻿Imports System.Xml
Imports Edtter.utility
Imports Edtter.frmFriendsTimeline

Public Class frmUserTimeline

    Private friendsTimelineUrl As String = "http://twitter.com/statuses/user_timeline/{0}.xml"
    Public twittuser As String

    '【1】 結果を引き渡すための変数を準備
    Dim result As String = ""

    '【2】 別スレッド処理完了後に呼び出すためのDelegateを準備
    Delegate Sub asyncReadDateDelegate()

    '【3】 別スレッドで実行する関数
    Private Sub asyncReadData()
        result = ReadData(Format(twittuser, friendsTimelineUrl), user, pass)
        '【6】 別スレッドでの処理終了後の処理の実行
        Invoke(New asyncReadDateDelegate(AddressOf writeUserTimeline))
    End Sub

    Private Sub frmUserTimeline_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Label3.Text = twittuser
        ListBox1.Items.Clear()

        '【4】 別スレッドを呼び出す処理
        Dim newthread As New System.Threading.Thread(AddressOf asyncReadData)
        newthread.Start()
    End Sub

    '【5】 別スレッド処理後の関数
    Private Sub writeUserTimeline()
        '【5】 今回別スレッドで行っている処理はコメントアウト
        'Dim result As String = ReadData(Format(twittuser, friendsTimelineUrl), user, pass)

        Dim doc As XmlDocument = New XmlDocument()
        doc.LoadXml(result)
        Dim nodes As XmlNodeList = doc.SelectNodes("//statuses/status")
        For Each node As XmlNode In nodes
            ListBox1.Items.Add(node.SelectSingleNode("text").InnerText)
        Next

        ListBox1.SelectedIndex = 0
    End Sub

    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        TextBox1.Text = ListBox1.SelectedItem.ToString
    End Sub

    Private Sub pictExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pictExit.Click
        Me.Close()
    End Sub

End Class